#ifndef LAYOUT_H
#define LAYOUT_H

#include <smilplugin.h>

#define STATE_INITIALIZING 0
#define STATE_INITIALIZED 1


class layout_window {
	public:
	       	layout_window(NPWindow *window);
		layout_window(layout_window *, const char *name,
				int x, int y, int dx, int dy);
		~layout_window();

		Window get_x_window(void) {return x_window;};
		int get_x(void) {return x;};
		int get_y(void) {return y;};
		int get_dx(void){return dx;};
		int get_dy(void){return dy;};

		layout_window *forward(void) {return fw;};
		layout_window *backward(void) {return bw;};
	private:
		/*
		 * State and locking mechanism.
		 */
		int state;
		
		/*
		 * Double linked list.
		 */
		class layout_window *fw;
		class layout_window *bw;
		/*
		 * Geometry and name.
		 */
		int x, y, dx, dy;
		const char *name;
		/*
		 * Browser related stuff.
		 */
		NPWindow *npwindow;

		/*
		 * X Window related variables.
		 */
		Window x_window;
		Window x_parent_window;
		Window x_root_window;
		NPSetWindowCallbackStruct *x_ws_info;
		GC x_gc, x_inv_gc;
		Display *x_display;
		XFontStruct *x_font;
		int x_fontheight;
};

class layout {
	public:
		layout(NPWindow *window);
		~layout(void);

		layout_window *find_layout(const char *name=NULL);
		layout_window *new_layout(int x, int y, int dx, int dy, 
				const char *name=NULL);

	private:
		class layout_window *first_layout_window;
};


#endif
