#ifndef PLAYER_H
#define PLAYER_H

#include <pthread.h>

#define STATE_FREE       0
#define STATE_STARTING   1
#define STATE_PLAYING    2
#define STATE_WAITING    4
#define STATE_QUIT       8

/* I know what! When we want to play two media simultaneously, we will make
 * more instances of this class. I made it! :-)
 */

class player {
	public:
		player(class nsPluginInstance *);
		~player(void);

		int start_play_this(char *);
		int start_show_this(char *);
		int start_play_this(class media_instance_descriptor *);

		void set_window(NPWindow *);

		int argc;
		char *argv[64];
		void *player_thread_function(void *);
		void *show_thread_function(void *);
		void draw_status(char *lines[]);
		int state;

	private:
		int execute_area_tags(const char *time_descriptor);
		int animate_window(double deciseconds);
		int current_second;
		area *current_area;
		FILE *control_stream;

		pid_t child;

		class media_instance_descriptor *current_media;
		
		class nsPluginInstance *instance;
		NPWindow *window;
		/* 
		 * X Window related stuff.
		 */
		Window x_window;
		NPSetWindowCallbackStruct *x_ws_info;
		GC x_gc, x_inv_gc;
		Display *x_display;
		XFontStruct *x_font;
		int x_fontheight;
		

		pthread_t player_thread;
		pthread_attr_t player_thread_attr;
		
};

#endif

