#ifndef SMILPLUGIN_H
#define SMILPLUGIN_H

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../config.h"

#include <mozilla-config.h>
#include <nsISupports.h>
#include "pluginbase.h"
#include "smilif.h"

#define STATE_INITIALIZING 0
#define STATE_EXECUTED 1


class nsPluginInstance:public nsPluginInstanceBase {
      public:
	nsPluginInstance(NPP aInstance);
	~nsPluginInstance(void);

	NPBool init(NPWindow *);
	void shut(void);
	NPBool isInitialized();

	/*
	 *
	 */
	NPError NewStream(NPMIMEType, NPStream *, NPBool, uint16 *);
	NPError DestroyStream(NPStream *, NPError);
  	int32 Write(NPStream *, int32, int32, void *);
	int32 WriteReady(NPStream *);
	int print_message(char *);

	/*
	 *
	 */
	NPError nsPluginInstance::SetWindow(NPWindow *);

	int FileDownloaded(char *, char *);
	
	NPP instance;

	class player *myplayer;
	class cachedfiles *filecache;
	char *base_url;

	pthread_mutex_t mutex_filecame;
	pthread_mutex_t mutex_end_of_show;
	pthread_cond_t cond_filecame;
	pthread_cond_t cond_end_of_show;

      private:
	int  state;
	class xml_parser *xml;
	NPWindow *window;
};


#endif

