#ifndef XML_H
#define XML_H

#include <string.h>
#include <stdlib.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include "smilplugin.h"

#define STATUS_EMPTY		0
#define STATUS_HAVE_VIDEO	1
#define STATUS_HAVE_AUDIO	2
#define STATUS_HAVE_IMAGE	4

#define STATUS_HAVE_DUR		8
#define STATUS_HAVE_SPEED	16
#define STATUS_HAVE_BEGIN	32

typedef struct area {
	int begin;
	int end;
	char *src;
	char *target;
	struct area *next;
} area;

class media_instance_descriptor {
	public:
	       	media_instance_descriptor(void);
		~media_instance_descriptor(void);

		int insert_area(char *src, char *target, char *begin, char *end);

		void print_debug(void);

		char *src;
		char *id;
		int begin;
		int end;
		int dur;
		double speed;
		int repeatCount;
		area *areas;     /* FIXME: We shoul write an iterator interface for these */
		int nareas;
		int maxareas;

		int status;
	private:
		nsPluginInstance *instance;
};


class xml_parser {
	public:
		xml_parser(nsPluginInstance *, char *filename = NULL);
		~xml_parser(void);
		
		int execute_document(void);
		int do_execute(xmlNodePtr);
		xmlNodePtr root;
	private:
		void parse_document(char *filename);
		void parse_body(xmlNodePtr);
		void parse_seq(xmlNodePtr);
		void parse_media(xmlNodePtr);
		void parse_areas(xmlNodePtr, media_instance_descriptor *);

		nsPluginInstance *instance;
		xmlDocPtr smil_doc;
		char *filename;
		
		pthread_t player_thread;
		pthread_attr_t player_thread_attr;
};


void *execute_thread_entry(void *);

#endif
